/*
 * Copyright (C) Rei HOBARA 2007
 * 
 * Name:
 *     LCG.cs
 * Class:
 *     Rei.Random.LCG
 * Purpose:
 *     A random number generator using Linear Congruential Generator(LCG).
 * Remark:
 * History:
 *     2007/10/6 initial release.
 * 
 */

using System;

namespace Rei.Random {

    /// <summary>
    /// LCG̋[WFl[^[NXB
    /// </summary>
    public class LCG : RandomBase {

        #region Field

        /// <summary>
        /// LCG̃p[^[̈B
        /// </summary>
        protected UInt32 A;
        /// <summary>
        /// LCG̃p[^[̈B
        /// </summary>
        protected UInt32 C;
        /// <summary>
        /// ԁB
        /// </summary>
        protected UInt32 x;

        #endregion

        /// <summary>
        /// ݎƂALCG[WFl[^[܂B
        /// </summary>
        public LCG() : this(Environment.TickCount) { }

        /// <summary>
        /// seedƂALCG[WFl[^[܂B
        /// </summary>
        public LCG( int seed ) : this(seed, 1664525, 1013904223) { }

        /// <summary>
        /// seedƂAparamAparamCŕ\LCG[WFl[^[܂B
        /// </summary>
        public LCG( int seed, UInt32 paramA, UInt32 paramC ) {
            A = paramA;
            C = paramC;
            x = (UInt32)seed;
        }

        /// <summary>
        /// Ȃ32bit̋[擾܂B
        /// </summary>
        public override uint NextUInt32() {
            x = (UInt32)((UInt64)x * A + C);
            return x;
        }

    }

}
